stages:
  - test
  - build
  - deploy

image: python:3

variables:
  CI_REGISTRY: registry.gitlab.com
  USERNAME: marco.olimpio
  REPO: ci-cd-workshop

validate_code:
  stage: test
  tags:
    - workshop
  before_script:
    - pip3 install -r app/requirements.txt
    - pip3 install pylint 
  script:
    - pylint app/app.py

build_artifact:
  image: docker:latest
  stage: build
  tags:
    - workshop
  script:
    - echo ${CI_REGISTRY}/${USERNAME}/${REPO}:${CI_COMMIT_SHA}
    - docker build -t ${CI_REGISTRY}/${USERNAME}/${REPO}:${CI_COMMIT_SHORT_SHA} app/

publish_artifact:
  image: docker:latest
  stage: deploy
  tags:
    - workshop
  before_script:
    - echo -n $CI_JOB_TOKEN | docker login -u gitlab-ci-token --password-stdin ${CI_REGISTRY}
  script:
    - docker push ${CI_REGISTRY}/${USERNAME}/${REPO}:${CI_COMMIT_SHORT_SHA}

# deploy_app:
#   script:
#     - echo "hmm... shouldn't you put a command here?"
